<?php
//-----------------------------------------
// Title: Horoscope component for MOS 4.5 
// Date: 2003/11/17 11:11
// Author: Tulga.G - tulga@netsoft.mn
// Copyright: Netsoft Co.,Ltd
//-----------------------------------------
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once( $mainframe->getPath( 'admin_html' ) );
require_once( $mainframe->getPath( 'class' ) );

$task = mosGetParam( $_REQUEST, 'task', array(0) );
$cid = mosGetParam( $_POST, 'cid', array(0) );
if (!is_array( $cid )) {
	$cid = array(0);
}

switch ($task) {

	case "new":
		edithoroscope( 0, $option );
		break;

	case "edit":
		edithoroscope( $cid[0], $option );
		break;

	case "save":
		savehoroscope( $option );
		break;

	case "publish":
		publishhoroscope( $cid, 1, $option );
		break;

	case "unpublish":
		publishhoroscope( $cid, 0, $option );
		break;

	case "remove":
		removehoroscope( $cid, $option );
		break;

	case "cancel":
		cancelhoroscope( $option );
		break;

	case "orderup":
		orderhoroscope( $cid[0], -1, $option );
		break;

	case "orderdown":
		orderhoroscope( $cid[0], 1, $option );
		break;

	default:
		showhoroscope( $option );
		break;
}

function showhoroscope( $option ) {
	global $database, $mainframe;

	$catid = $mainframe->getUserStateFromRequest( "catid{$option}", 'catid', 0 );
	$limit = $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', 10 );
	$limitstart = $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 );

	// get the total number of records
	$database->setQuery( "SELECT count(*) FROM #__horoscope"
	. ($catid ? "\nWHERE catid='$catid'" : "")
	);

	$total = $database->loadResult();
	echo $database->getErrorMsg();

	require_once("includes/pageNavigation.php");
	$pageNav = new mosPageNav( $total, $limitstart, $limit );

	$database->setQuery( "SELECT a.*, c.name AS catname, u.name AS editor"
	. "\nFROM #__horoscope AS a"
	. "\nLEFT JOIN #__categories AS c ON c.id = a.catid"
	. "\nLEFT JOIN #__users AS u ON u.id = a.checked_out"
	. ($catid ? "\nWHERE a.catid='$catid'" : "")
	. "\nORDER BY a.ordering"
	. "\nLIMIT $pageNav->limitstart,$pageNav->limit"
	);

	$rows = $database->loadObjectList();
	
	$imageFiles = mosReadDirectory( "../images/stories/" );
	$images = array(  mosHTML::makeOption( '', 'Select Image' ) );
	foreach ($imageFiles as $file) {
		if (eregi( "bmp|gif|jpg|png", $file )) {
			$images[] = mosHTML::makeOption( $file );
		}
	}

	$imagelist = mosHTML::selectList( $images, 'images', "class=\"inputbox\" size=\"1\""
		. " onchange=\"javascript:if (document.forms[0].images.options[selectedIndex].value!='') {document.imagelib.src='../images/stories/' + document.forms[0].images.options[selectedIndex].value} else {document.imagelib.src='../images/stories/blank.png'}\"",
		'value', 'text', $rows->images );
		
	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	// get list of categories
	$categories[] = mosHTML::makeOption( '0', 'Select Category' );
	$categories[] = mosHTML::makeOption( '0', '- All Categories' );
	$database->setQuery( "SELECT id AS value, title AS text FROM #__categories"
	. "\nWHERE section='$option' ORDER BY ordering" );
	$categories = array_merge( $categories, $database->loadObjectList() );

	$catlist = mosHTML::selectList( $categories, 'catid', 'class="inputbox" size="1" onchange="document.adminForm.submit();"',
	'value', 'text', $catid );
	unset( $categories );

	HTML_horoscope::showhoroscope( $rows, $catlist, $pageNav, $option, $imagelist );
}

function edithoroscope( $id, $option ) {
	global $database, $my, $mosConfig_absolute_path;

	$catid = intval( mosGetParam( $_REQUEST, 'catid', 0 ) );

	$row = new moshoroscope( $database );
	// load the row from the db table
	$row->load( $id );

	if ($id) {
		// do stuff for existing records
		$row->checkout( $my->id );
	} else {
		// do stuff for new records
		$row->ordering = 9999;
	}
	
	$ipos[] = mosHTML::makeOption( 'right' );
	$ipos[] = mosHTML::makeOption( 'left' );

	$iposlist = mosHTML::selectList( $ipos, 'imagepos', 'class="inputbox" size="1"',
		'value', 'text', $row->imagepos );

	// get list of categories
	$categories[] = mosHTML::makeOption( '0', 'Select Category' );
	$database->setQuery( "SELECT id AS value, title AS text FROM #__categories"
	. "\nWHERE section='$option' ORDER BY ordering" );
	$categories = array_merge( $categories, $database->loadObjectList() );

	$catlist = mosHTML::selectList( $categories, 'catid', 'class="inputbox" size="1"',
	'value', 'text', $row->catid );
	unset( $categories );

	if ($id) {
		// build the html select list for ordering
		$order = mosGetOrderingList( "SELECT a.ordering AS value, a.name AS text"
			. "\nFROM #__horoscope AS a"
			. "\nORDER BY a.ordering"
		);
		$orderlist = mosHTML::selectList( $order, 'ordering', 'class="inputbox" size="1"',
		'value', 'text', intval( $row->ordering ) );
	} else {
		$orderlist = "<input type=\"hidden\" name=\"ordering\" value=\"$row->ordering\" />"
		. " New items default to the last place";
	}
	
	$imageFiles = mosReadDirectory( "../images/stories/" );
	$images = array(  mosHTML::makeOption( '', 'Select Image' ) );
	foreach ($imageFiles as $file) {
		if (eregi( "bmp|gif|jpg|png", $file )) {
			$images[] = mosHTML::makeOption( $file );
		}
	}

	$imagelist = mosHTML::selectList( $images, 'images', "class=\"inputbox\" size=\"1\""
		. " onchange=\"javascript:if (document.forms[0].images.options[selectedIndex].value!='') {document.imagelib.src='../images/stories/' + document.forms[0].images.options[selectedIndex].value} else {document.imagelib.src='../images/stories/blank.png'}\"",
		'value', 'text', $row->images );

	HTML_horoscope::edithoroscope( $row, $catlist, $orderlist, $option, $imagelist, $iposlist );
}

function savehoroscope( $option ) {
	global $database, $my;

	$row = new moshoroscope( $database );
	if (!$row->bind( $_POST )) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	// save the changes
	if (!$row->store()) {
		echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	$row->checkin();
	$row->updateOrder();

	mosRedirect( "index2.php?option=$option" );
}

function publishhoroscope( $cid, $publish, $option ) {
	global $database;

	if (count( $cid ) < 1) {
		$action = $publish ? 'publish' : 'unpublish';
		echo "<script> alert('Select a module to $action'); window.history.go(-1);</script>\n";
		exit;
	}

	$cids = implode( ',', $cid );

	$database->setQuery( "UPDATE #__horoscope SET published='$publish'"
	. "\nWHERE id IN ($cids) AND (checked_out=0 OR (checked_out='$my->id'))"
	);
	if (!$database->query()) {
		echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (count( $cid ) == 1) {
		$row = new moshoroscope( $database );
		$row->checkin( $cid[0] );
	}

	mosRedirect( "index2.php?option=$option" );
}

function removehoroscope( &$cid, $option ) {
	global $database;

	if (!is_array( $cid ) || count( $cid ) < 1) {
		echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
		exit;
	}
	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$database->setQuery( "DELETE FROM #__horoscope WHERE id IN ($cids) AND checked_out='0'" );
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
		}
	}

	mosRedirect( "index2.php?option=$option" );
}

function cancelhoroscope( $option ) {
	global $database;

	$row = new moshoroscope( $database );
	$row->bind( $_POST );
	$row->checkin();
	mosRedirect( "index2.php?option=$option" );
}

function orderhoroscope( $id, $inc, $option ) {
	global $database;

	$limit = mosGetParam( $_REQUEST, 'limit', 0 );
	$limitstart = mosGetParam( $_REQUEST, 'limitstart', 0 );
	$catid = intval( mosGetParam( $_REQUEST, 'catid', 0 ) );

	$row = new moshoroscope( $database );
	$row->load( $id );
	$row->move( $inc );

	mosRedirect( "index2.php?option=$option" );
}
?>